unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls, Buttons, XPMan;

type
  TForm1 = class(TForm)
    Area: TImage;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N7: TMenuItem;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    XPManifest1: TXPManifest;
    Empty: TImage;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N5: TMenuItem;
    Label1: TLabel;
    N6: TMenuItem;
    N8: TMenuItem;
    Bevel1: TBevel;
    SpeedButton2: TSpeedButton;
    ComboBox1: TComboBox;
    SpeedButton3: TSpeedButton;
    ComboBox2: TComboBox;
    SpeedButton4: TSpeedButton;
    ComboBox3: TComboBox;
    procedure CreatePoint(x,y:integer);
    procedure ClickPoint(Sender: TObject);
    procedure ShowPointNum(Number:integer);
    procedure ShowRebro(Point1,Point2:integer);
    procedure MoveImage(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure AreaClick(Sender: TObject);
    procedure Draw(Point1,Point2:integer);
    procedure NewGraph;
    procedure DrawGraph;
    procedure SaveGraph;
    procedure SaveBitmap;
    procedure LoadGraph;
    function Enter(symbol:string):boolean;
    function Max(box:TCombobox):integer;
    function Min(box:TCombobox):integer;
    function DoubleNum(Num:integer; Box: TCombobox):boolean;
    procedure DblClickPoint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure N8Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure ComboBox2DropDown(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure ComboBox3DropDown(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Map: array of array of integer;
  n,c,last:integer;
implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.ShowPointNum(Number:integer);
var
image:Timage;
i:integer;
begin
Image:=Timage(FindComponent('Point'+inttostr(Number)));
Area.Canvas.Pen.Color:=clBlue;
Area.Canvas.Pen.Width:=3;
area.Canvas.Ellipse(image.Left-5,image.Top-33,image.Left+15,image.Top-13);
Area.Canvas.Pen.Color:=clblack;
Area.Canvas.Pen.Width:=1;
end;

procedure TForm1.CreatePoint(x,y:integer);
begin
n:=n+1;
with TImage.Create(self) do begin
TransParent:=true; AutoSize:=true; showhint:=true;
picture.LoadFromFile('.bmp');
left:=x; top:=y;
name:='Point'+inttostr(n);
parent:=form1;
OnDblClick:=DblClickPoint;
OnMouseMove:=MoveImage;
Onclick:=clickPoint;
end;
SetLength(Map,n,n);
end;

procedure TForm1.ClickPoint(Sender: TObject);
var
i:integer;
begin
if c=0 then last:=strtoint(copy((Sender as Timage).Name,6,20));
c:=1;
end;

procedure TForm1.MoveImage(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
(sender as Timage).Hint:=(sender as Timage).Name;
if Shift=[ssLeft] then begin
(sender as Timage).Left:=(sender as Timage).Left+x-5;
(sender as Timage).top:=(sender as Timage).top+y-5;
DrawGraph;
end;
end;

procedure TForm1.AreaClick(Sender: TObject);
var
i:integer;
begin
c:=0;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
i,q:integer;
x,y:integer;
begin
q:=0;
Randomize;
while q<>strtoint(form2.Edit1.text) do begin
q:=q+1;
 if form2.CheckBox1.Checked=true then begin
 x:=random(Area.Width);
 y:=random(Area.Height)+28;
 end else begin
 x:=strtoint(form2.Edit2.text);
 y:=strtoint(form2.Edit3.text);
 end;
 CreatePoint(x,y);
end;
label1.Caption:=inttostr(n);
combobox1.Text:=inttostr(n);
end;

procedure TForm1.DrawGraph;
var
x,y:integer;
begin
Area.Picture:=Empty.Picture;
for y:=0 to High(Map) do begin
 for x:=0 to High(Map) do begin
  if Map[x,y]<>0 then begin
  Draw(x+1,y+1);
  end;
 end;
end;
end;

procedure TForm1.Draw(Point1,Point2:integer);
var
Image1,Image2:TImage;
begin
Image1:=Timage(FindComponent('Point'+inttostr(Point1)));
Image2:=Timage(FindComponent('Point'+inttostr(Point2)));
Area.Canvas.MoveTo(image1.Left+5,image1.Top+5-28);
Area.Canvas.LineTo(image2.Left+5,image2.Top+5-28);
end;

procedure TForm1.SaveGraph;
var
x,y:integer;
begin
AssignFile(output,'Graph.txt');
Rewrite(output);
writeln(High(Map)+1);
for y:=0 to High(Map) do begin
 for x:=0 to High(Map) do begin
 write(Map[x,y],' ');
 end;
writeln;
end;
closefile(output);
end;

procedure TForm1.LoadGraph;
var
x,y,s,i,a:integer;
begin
Randomize;
n:=0; c:=0;
AssignFile(input,'Graph.txt');
Reset(input);
Read(s);
for i:=1 to s do begin
CreatePoint(Random(area.Width),Random(Area.Height)+28);
end;
for y:=0 to s-1 do begin
 for x:=0 to s-1 do begin
 read(Map[x,y]);
 end;
end;
closefile(input);
DrawGraph;
end;

procedure TForm1.DblClickPoint(Sender: TObject);
var
new:integer;
begin
if c=1 then begin
new:=strtoint(copy((Sender as Timage).Name,6,20));
if new<>Last then begin
Map[last-1,new-1]:=strtoint(form2.Edit4.Text);
Map[new-1,last-1]:=strtoint(form2.Edit4.Text);
Draw(last,new);
end;
c:=0;
end;
end;

procedure TForm1.NewGraph;
var
i:integer;
label Return;
begin
SetLength(Map,0,0);
Area.Picture:=Empty.Picture;
label1.Caption:='0';
Combobox1.Text:='0';
Combobox2.Text:='';
c:=0; n:=0;
Return:
for i:=0 to ComponentCount-1 do begin
 if (Components[i] is TImage) and (Timage(Components[i]).Name<>'Area') and (Timage(Components[i]).Name<>'Empty') then begin
 Timage(Components[i]).Destroy;
 Goto Return;
 end;
end;
end;

procedure TForm1.SaveBitmap;
var
i:integer;
begin
for i:=0 to ComponentCount-1 do begin
 if (Components[i] is TImage) and (Timage(Components[i]).Name<>'Area') and (Timage(Components[i]).Name<>'Empty') then begin
 Area.Canvas.Draw(Timage(Components[i]).Left,Timage(Components[i]).Top-28,Timage(Components[i]).Picture.Graphic);
 end;
end;
Area.Picture.SaveToFile('Graph.bmp');
end;

procedure TForm1.N3Click(Sender: TObject);
begin
SaveGraph;
SaveBitmap;
end;

procedure TForm1.N10Click(Sender: TObject);
begin
NewGraph;
LoadGraph;
end;

procedure TForm1.N5Click(Sender: TObject);
begin
form2.Show;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
NewGraph;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=vk_f1 then NewGraph;
if key=vk_f2 then begin
SaveGraph;
SaveBitmap;
showmessage(' ');
end;
if key=vk_f3 then begin
NewGraph;
LoadGraph;
showmessage(' ');
end;
if key=vk_f4 then form2.Show;
end;

procedure TForm1.N8Click(Sender: TObject);
begin
ShowMessage('   '+#13#10+
            '  1.0');
end;

procedure TForm1.N6Click(Sender: TObject);
begin
showmessage('   '+#13#10+
            '    .'+#13#10+
            '      '+#13#10+
            '.    '+#13#10+
            '  " ".  '+#13#10+
            '   -   '+#13#10+
            '.     '+#13#10+
            ' .    '+#13#10+
            '      '+#13#10+
            ' -    .'+#13#10+
            '     '+#13#10+
            '     '+#13#10+
            ' .    '+#13#10+
            '      '+#13#10+
            '     ');
end;

procedure TForm1.N4Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.ComboBox1DropDown(Sender: TObject);
var
i:integer;
begin
Combobox1.Clear;
Combobox1.Text:=inttostr(high(Map)+1);
for i:=1 to n do begin
Combobox1.Items.Add(inttostr(i));
end;
end;

function TForm1.Max(box:TCombobox):integer;
var
i,best:integer;
begin
best:=strtoint(Box.Items[0]);
for i:=0 to Box.Items.Count-1 do begin
if best<strtoint(Box.Items[i]) then best:=strtoint(Box.Items[i]);
end;
result:=best;
end;

function TForm1.Min(box:TCombobox):integer;
var
i,best:integer;
begin
best:=strtoint(Box.Items[0]);
for i:=0 to Box.Items.Count-1 do begin
if best>strtoint(Box.Items[i]) then best:=strtoint(Box.Items[i]);
end;
result:=best;
end;

procedure TForm1.ShowRebro(Point1,Point2:integer);
var
img1,img2:Timage;
begin
img1:=Timage(FindComponent('Point'+inttostr(point1)));
img2:=Timage(FindComponent('Point'+inttostr(point2)));
Area.Canvas.Pen.Color:=clBlue;
Area.Canvas.Pen.Width:=2;
Area.Canvas.MoveTo(img1.Left+5,img1.Top-23);
Area.Canvas.LineTo(img2.Left+5,img2.Top-23);
Area.Canvas.Pen.Width:=1;
Area.Canvas.Pen.Color:=clBlack;
end;

function TForm1.DoubleNum(Num:integer; Box: TCombobox):boolean;
var
i:integer;
begin
for i:=0 to Box.items.Count-1 do begin
 if Num=strtoint(Box.items[i]) then begin
 Result:=true;
 exit;
 end;
end;
Result:=false;
end;

procedure TForm1.ComboBox2DropDown(Sender: TObject);
var
x,y,k,j:integer;
begin
k:=0;
Combobox2.Clear;
for y:=0 to High(Map) do begin
 for x:=0 to High(Map) do begin
  if Map[x,y]<>0 then k:=k+1;
 end;
 if DoubleNum(k, Combobox2)=false then Combobox2.Items.Add(inttostr(k));
 k:=0;
end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
Area.Picture:=Empty.Picture;
DrawGraph;
if (Enter(Combobox1.Text)=true) and (strtoint(Combobox1.Text)<=High(Map)+1) and (strtoint(Combobox1.Text)>0) then begin
ShowPointNum(strtoint(combobox1.text));
end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var
x,y,k:integer;
image:TImage;
begin
k:=0;
Area.Picture:=Empty.Picture;
DrawGraph;
if (Enter(Combobox2.Text)=true) and (strtoint(Combobox2.Text)<=High(Map)+1) and (strtoint(Combobox2.Text)>0) then begin
for y:=0 to High(Map) do begin
 for x:=0 to High(Map) do begin
  if (x<>y) and (Map[x,y]<>0) then k:=k+1;
 end;
 if k=strtoint(Combobox2.Text) then begin
 ShowPointNum(y+1);
 end;
 k:=0;
end;
end;
end;

function TForm1.Enter(symbol:string):boolean;
var
a:integer;
begin
if TryStrToInt(symbol,a)=false then result:=false else result:=true;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
var
x,y:integer;
begin
Area.Picture:=Empty.Picture;
DrawGraph;
if (Enter(Combobox3.Text)=true) and (Combobox3.Items.count<=High(Map)+1) then begin
 for y:=0 to High(Map) do begin
  for x:=0 to High(Map) do begin
   if Map[x,y]<>0 then if Map[x,y]=strtoint(Combobox3.Text) then showrebro(x+1,y+1);
  end;
 end;
end;
end;

procedure TForm1.ComboBox3DropDown(Sender: TObject);
var
x,y,j:integer;
begin
Combobox3.Clear;
for y:=0 to High(Map) do begin
 for x:=0 to High(Map) do begin
 if Map[x,y]<>0 then if DoubleNum(Map[x,y], Combobox3)=false then Combobox3.Items.Add(inttostr(Map[x,y]));
 end;
end;
end;

end.
